<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class VendasRealizadasPeriodo {

	public function __construct(EntityManager $entityManager) {
        ini_set('max_execution_time', 1800);
        ini_set('memory_limit', '1G');
        $this->entityManager = $entityManager;
    }

    public function getReport($conditions) {
    	return $this->entityManager->getConnection()->fetchAll(self::REL_VENDAS_REALIZADAS_PERIODO, $conditions);
	}

    const REL_VENDAS_REALIZADAS_PERIODO = "
        SELECT B.*, (CASE WHEN PV.IDENVIACDBARXML = 'X' AND PX.CDPRODUTOEXT IS NOT NULL  THEN PX.CDPRODUTOEXT ELSE 'Sem Código externo' END) AS CDPRODUTOEXT FROM (SELECT 
F.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL, F.CDFILIAL,
           'Caixa : ' || V.CDCAIXA || ' | Nr. Ven.: ' || V.NRSEQVENDA || ' | Dt. Ven.: ' || TO_CHAR(V.DTVENDA, 'DD/MM/YYYY HH24:MI:SS') || ' | Cup./N. Fiscal: ' || NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE) || ' | Cli./Cons.: ' || C.NMCONSUMIDOR || ' | Vend.: ' || VE.NMRAZSOCVEN || ' | Valor Repique: ' || NVL(V.VRREPIQUEVENDA,0)  AS LABELVENDARECEBIMENTO, 
           P.CDARVPROD,
           P.CDPRODUTO,
           P.NMPRODUTO,
           P.SGUNIDADE,
           IT.VRUNITVEND, 
           IT.QTPRODVEND AS QTPRODVEND, 
           IT.VRDESITVEND, 
           IT.VRACRITVEND,   
           TRUNC( IT.QTPRODVEND * ( IT.VRUNITVEND + NVL( IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND,0) AS VRBRUTO,
           TRUNC( IT.QTPRODVEND * ( IT.VRUNITVEND + NVL( IT.VRUNITVENDCL,0)),2) - (NVL(IT.VRDESITVEND,0)) + NVL(IT.VRACRITVEND,0)  AS VRTOTAL
            FROM VENDA V, 
                 ITEMVENDA IT, 
                 PRODUTO P,
                 VENDEDOR VE,
                 (SELECT CDFILIAL, NMFILIAL, CDCAIXA
                    FROM V_FILIALLOJACAIXA FLC 
                   WHERE (INSTR( :CDFILIAL, FLC.CDFILIAL) <> 0)
                     AND (((INSTR(:CDFILICAIXA, FLC.CDFILIAL || FLC.CDCAIXA) <> 0)) OR (:TCDFILICAIXA = 'T'))) F,
                 (SELECT CL.CDCLIENTE, CL.NMRAZSOCCLIE, CO.CDCONSUMIDOR, CO.NMCONSUMIDOR
                    FROM CONSUMIDOR CO,
                         CLIENTE CL
                   WHERE CO.CDCLIENTE = CL.CDCLIENTE ) C 
            WHERE V.CDFILIAL   = F.CDFILIAL
              AND V.CDCAIXA    = F.CDCAIXA
              AND V.CDFILIAL   = IT.CDFILIAL 
              AND V.CDCAIXA    = IT.CDCAIXA
              AND V.NRSEQVENDA = IT.NRSEQVENDA             
              AND P.CDPRODUTO  = IT.CDPRODUTO 
              AND V.CDCLIENTE  = C.CDCLIENTE (+)
              AND V.CDCONSUMIDOR = C.CDCONSUMIDOR (+)
              AND V.CDVENDEDOR = VE.CDVENDEDOR (+)
              AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIM
              AND (((INSTR(:IDSITUVENDA, V.IDSITUVENDA) <> 0)) OR (:IDSITUVENDA = 'T'))
              AND ((INSTR( :CDFILICLIENTE, V.CDFILIAL||V.CDCLIENTE) <> 0) OR (:TCDFILICLIENTE = 'T'))
              AND (((INSTR(:CDCONSCLI, C.CDCLIENTE || V.CDCONSUMIDOR) <> 0)) OR (:TCDCONSCLI = 'T'))
            ORDER BY F.CDFILIAL, V.CDCAIXA, V.DTVENDA, P.CDARVPROD) B JOIN PARAVEND PV ON PV.CDFILIAL =  B.CDFILIAL LEFT JOIN PRODEXTERNO PX ON B.CDFILIAL = PX.CDFILIAL AND B.CDPRODUTO = PX.CDPRODUTO";
}